<form autocomplete="off" role="form" #FORM_DATA="ngForm">
    <div class="row">
        <div class="col-3">
            <div class="form-group">
                <label for="username">User Name</label>
                <input type="text" class="form-control" name="username" id="username" [(ngModel)]="formData.username"
                    required #userNameField="ngModel">
                <ng-container
                    *ngTemplateOutlet="errorTemp;context:{element:userNameField,name:'User Name'}"></ng-container>
            </div>
        </div>
        <div class="col-3">
            <div class="form-group">
                <label for="name">Name</label>
                <input type="text" class="form-control" name="name" id="name" [(ngModel)]="formData.name" required
                    #nameField="ngModel">
                <ng-container *ngTemplateOutlet="errorTemp;context:{element:nameField,name:'Name'}"></ng-container>
            </div>
        </div>
    </div>
</form>

<ng-template #errorTemp let-eleName="name" let-element="element">
    <ng-container *ngIf="element?.touched">
        <ng-container *ngIf="element.errors?.required">
            <span class="text-danger">{{eleName}} is required</span>
        </ng-container>
    </ng-container>
</ng-template>